// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'openfb', 'ngCordova', 'starter.controllers', 'starter.services', 'ionicLazyLoad', 'ngMessages'])

        .run(function ($rootScope, $state, $ionicPlatform, $window, OpenFB, $cordovaSplashscreen) {

            $rootScope.range = 10;

            $rootScope.scroll = true;
            OpenFB.init(['818030048279735'], 'http://localhost:8100/oauthcallback.html', $window.sessionStorage);

            $ionicPlatform.ready(function () {

                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                }


                if (window.StatusBar) {
                    StatusBar.styleDefault();
                }
                ionic.Platform.isFullScreen = true;
            });

            $rootScope.$on('OAuthException', function () {
                $state.go('tab.dash');
            });



        })

        .config(function ($stateProvider, $urlRouterProvider) {

            // Ionic uses AngularUI Router which uses the concept of states
            // Learn more here: https://github.com/angular-ui/ui-router
            // Set up the various states which the app can be in.
            // Each state's controller can be found in controllers.js
            $stateProvider

                    // setup an abstract state for the tabs directive
                    .state('tab', {
                        url: "/tab",
                        abstract: true,
                        templateUrl: "templates/tabs.html",
                        controller: 'TabCtrl'
                    })

                    // Each tab has its own nav history stack:

                    .state('tab.dash', {
                        url: '/dash',
                        views: {
                            'tab-dash': {
                                templateUrl: 'templates/tab-dash.html',
                                controller: 'DashCtrl'
                            }
                        }
                    })

                    .state('tab.feed', {
                        url: '/feed',
                        views: {
                            'tab-dash': {
                                templateUrl: 'templates/feed.html',
                                controller: 'FeedCtrl'
                            }
                        }
                    })
                    .state('tab.photos', {
                        url: '/photos',
                        views: {
                            'tab-dash': {
                                templateUrl: 'templates/photos.html',
                                controller: 'PhotosCtrl'
                            }
                        }
                    })
                    .state('tab.about', {
                        url: '/about',
                        views: {
                            'tab-dash': {
                                templateUrl: 'templates/about.html',
                                controller: 'AboutCtrl'
                            }
                        }
                    })
                    .state('tab.member', {
                        url: '/member',
                        views: {
                            'tab-dash': {
                                templateUrl: 'templates/membership.html',
                                controller: 'MembershipCtrl'
                            }
                        }
                    })

                    .state('tab.contact', {
                        url: '/contact',
                        views: {
                            'tab-dash': {
                                templateUrl: 'templates/contact.html',
                                controller: 'ContactCtrl'
                            }
                        }
                    })

                    .state('picture', {
                        url: "/feed/picture/:feedId",
                        templateUrl: "templates/picture.html",
                        controller: "PictureCtrl"


                    })
                    .state('largephoto', {
                        url: "/photos/photo_large/:photoId",
                        templateUrl: "templates/photo_large.html",
                        controller: "LargePhotoCtrl"


                    })
                    .state('blank', {
                        url: "/blank",
                        templateUrl: 'templates/blank.html',
                        controller: "LargePCtrl"

                    })

                    .state('ideology', {
                        url: '/ideology',
                        templateUrl: 'templates/ideology.html',
                        controller: 'IdeologyCtrl'

                    })

                    .state('history', {
                        url: '/history',
                        templateUrl: 'templates/history.html',
                        controller: 'HistoryCtrl'

                    })

                    .state('pdfparty', {
                        url: '/pdfparty',
                        controller: 'PdfCtrl'

                    })

                    .state('loksabha', {
                        url: '/loksabha',
                        templateUrl: 'templates/lok_sabha.html',
                        controller: 'LokSabhaCtrl'

                    })
                    .state('rajyasabha', {
                        url: '/rajyasabha',
                        templateUrl: 'templates/rajya_sabha.html',
                        controller: 'RajyaSabhaCtrl'

                    })
                    .state('ram_manohar_lohia', {
                        url: '/ram_manohar_lohia',
                        templateUrl: 'templates/ram_manohar_lohia.html',
                        controller: 'RamManoharLohiaCtrl'

                    })
                    .state('mulayam_singh_yadav', {
                        url: '/mulayam_singh_yadav',
                        templateUrl: 'templates/mulayam_singh_yadav.html',
                        controller: 'MulayamSinghYadavCtrl'

                    })
                    .state('our_chief_minister', {
                        url: '/our_chief_minister',
                        templateUrl: 'templates/our_chief_minister.html',
                        controller: 'OurChiefMinisterCtrl'

                    })
                    .state('mlc', {
                        url: '/mlc',
                        templateUrl: 'templates/mlc.html',
                        controller: 'MlcCtrl'

                    })
                    .state('mla', {
                        url: '/mla',
                        templateUrl: 'templates/mla.html',
                        controller: 'MlaCtrl'

                    })
                    .state('zila_adhyaksh', {
                        url: '/zila_adhyaksh',
                        templateUrl: 'templates/zila_adhyaksh.html',
                        controller: 'ZilaAdhyakshCtrl'

                    })

            // if none of the above states are matched, use this as the fallback
            $urlRouterProvider.otherwise('/tab/dash');

        })

        .directive('ngFocus', ['$parse', function ($parse) {
                return function (scope, element, attr) {
                    var fn = $parse(attr['ngFocus']);
                    element.on('focus', function (event) {
                        scope.$apply(function () {
                            fn(scope, {$event: event});
                        });
                    });
                };
            }])
        .directive('ngBlur', ['$parse', function ($parse) {
                return function (scope, element, attr) {
                    var fn = $parse(attr['ngBlur']);
                    element.on('blur', function (event) {
                        scope.$apply(function () {
                            fn(scope, {$event: event});
                        });
                    });
                };
            }]);
